;; bugtest.asm
;; tests for known bugs in avra-1.3.0

#ifndef BUG_CHECK
#define BUG_CHECK
#endif
#ifndef BUG_CHECK
        .warning " #ifndef bug"
#endif

#ifdef BUG_CHECK1
        .warning " #ifdef #else bug"
#else
 #define BUG_CHECK1
#endif
        
#ifndef BUG_CHECK2
#endif
#ifdef BUG_CHECK2
        .warning "first #ifndef bug2"
#endif
#ifndef BUG_CHECK2
#define BUG_CHECK2
#endif
#ifndef BUG_CHECK2
        .warning "second #ifndef bug2"
#endif

#define BUG_CHECK3
#ifndef BUG_CHECK3
        .warning " #ifndef bug3"
#endif
#undef BUG_CHECK3
#ifdef BUG_CHECK3
        .warning " #undef bug"
#endif

#undef BUG_CHECK4

.nolist
.include "m8def.inc"        ;ATmega8
;.include "m1284Pdef.inc"    ;ATmega1284P
.list

;#undef SRAM_START  ;should give a warning, and an error later
;#undef XH	    ;should give a warning

#ifndef SRAM_START
        .equ SRAM_START=0x60
#endif

        rjmp main
        nop
main:   ldi r16, low(RAMEND)
        out SPL, r16            ; Init Stackpointer L
        ldi r16, high(RAMEND)
        out SPH, r16            ; Init Stackpointer H
        ldi XL, low(SRAM_START)
        ldi XH, high(SRAM_START)
mainloop:
        nop
        rjmp mainloop
