;; undeftest.asm  Testen von #undef

.nolist
.include "m8def.inc"
.list
	rjmp main

;#define BIGLOOP

.def counter=r16
.def counterH=r17

#ifndef BIGLOOP
.undef counterH
#endif

.undef counter2		;undef of not existing constant

my_loop:
	push counter
.ifdef counterH
	push counterH
.endif
#ifdef BIGLOOP
	clr r1
	cp  counter, r1
	cpc counterH, r1
#else
	tst  counter
#endif
	breq _L2
_L1:	nop
#ifndef BIGLOOP
	dec counter
#else
	subi counter, 1
	sbc counterH, r1
#endif
	brne _L1
_L2:
.ifdef counterH
	pop counterH
.endif
	pop counter
	ret
	
main:   ldi r16, low(RAMEND)
        out SPL, r16
        ldi r16, high(RAMEND)
        out SPH, r16
.set temp_var=1000
	ldi counter, low(temp_var)
 #ifdef counterH
	ldi counterH, high(temp_var)
 #endif
;	ldi temp_var, 100       ;this should give an error
.undef temp_var
;	ldi r16, temp_var       ;this should give an error
;	ldi r17, low(temp_var)	;this should give an error

.undef counter
.undef counterH

mainloop:
;	ldi counter, low(1000) 	 ;this should give an error
;	ldi counterH, high(1000) ;this should give an error
	ldi r16, low(1000)
	ldi r17, high(1000)
	rcall my_loop
	rjmp mainloop

.def counter=r18
test3:
	push counter
	nop
	pop counter
	ret
